# coding: utf-8

"""
    Pure Fusion API

    Pure Fusion is fully API-driven. Most APIs which change the system (POST, PATCH, DELETE) return an Operation in status \"Pending\" or \"Running\". You can poll (GET) the operation to check its status, waiting for it to change to \"Succeeded\" or \"Failed\".   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from fusion.api_client import ApiClient


class PlacementGroupsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_placement_group(self, body, tenant_name, tenant_space_name, **kwargs):  # noqa: E501
        """Creates a Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_placement_group(body, tenant_name, tenant_space_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PlacementGroupPost body: (required)
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Operation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_placement_group_with_http_info(body, tenant_name, tenant_space_name, **kwargs)  # noqa: E501
        else:
            (data) = self.create_placement_group_with_http_info(body, tenant_name, tenant_space_name, **kwargs)  # noqa: E501
            return data

    def create_placement_group_with_http_info(self, body, tenant_name, tenant_space_name, **kwargs):  # noqa: E501
        """Creates a Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_placement_group_with_http_info(body, tenant_name, tenant_space_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PlacementGroupPost body: (required)
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Operation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'tenant_name', 'tenant_space_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_placement_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_placement_group`")  # noqa: E501
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `create_placement_group`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `create_placement_group`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Operation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_placement_group(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Deletes a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_placement_group(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Operation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_placement_group_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_placement_group_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
            return data

    def delete_placement_group_with_http_info(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Deletes a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_placement_group_with_http_info(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Operation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tenant_name', 'tenant_space_name', 'placement_group_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_placement_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `delete_placement_group`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `delete_placement_group`")  # noqa: E501
        # verify the required parameter 'placement_group_name' is set
        if ('placement_group_name' not in params or
                params['placement_group_name'] is None):
            raise ValueError("Missing the required parameter `placement_group_name` when calling `delete_placement_group`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501
        if 'placement_group_name' in params:
            path_params['placement_group_name'] = params['placement_group_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups/{placement_group_name}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Operation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_placement_group(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Gets a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_group(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_placement_group_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_placement_group_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
            return data

    def get_placement_group_with_http_info(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Gets a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_group_with_http_info(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tenant_name', 'tenant_space_name', 'placement_group_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_placement_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `get_placement_group`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `get_placement_group`")  # noqa: E501
        # verify the required parameter 'placement_group_name' is set
        if ('placement_group_name' not in params or
                params['placement_group_name'] is None):
            raise ValueError("Missing the required parameter `placement_group_name` when calling `get_placement_group`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501
        if 'placement_group_name' in params:
            path_params['placement_group_name'] = params['placement_group_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups/{placement_group_name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PlacementGroup',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_placement_group_by_id(self, placement_group_id, **kwargs):  # noqa: E501
        """Gets a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_group_by_id(placement_group_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str placement_group_id: The Placement Group ID (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_placement_group_by_id_with_http_info(placement_group_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_placement_group_by_id_with_http_info(placement_group_id, **kwargs)  # noqa: E501
            return data

    def get_placement_group_by_id_with_http_info(self, placement_group_id, **kwargs):  # noqa: E501
        """Gets a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_group_by_id_with_http_info(placement_group_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str placement_group_id: The Placement Group ID (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroup
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['placement_group_id', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_placement_group_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'placement_group_id' is set
        if ('placement_group_id' not in params or
                params['placement_group_id'] is None):
            raise ValueError("Missing the required parameter `placement_group_id` when calling `get_placement_group_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'placement_group_id' in params:
            path_params['placement_group_id'] = params['placement_group_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/resources/placement-groups/{placement_group_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PlacementGroup',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_placement_group_sessions(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Gets iSCSI sessions data of a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_group_sessions(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: SessionList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_placement_group_sessions_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_placement_group_sessions_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
            return data

    def get_placement_group_sessions_with_http_info(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Gets iSCSI sessions data of a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_group_sessions_with_http_info(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: SessionList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tenant_name', 'tenant_space_name', 'placement_group_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_placement_group_sessions" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `get_placement_group_sessions`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `get_placement_group_sessions`")  # noqa: E501
        # verify the required parameter 'placement_group_name' is set
        if ('placement_group_name' not in params or
                params['placement_group_name'] is None):
            raise ValueError("Missing the required parameter `placement_group_name` when calling `get_placement_group_sessions`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501
        if 'placement_group_name' in params:
            path_params['placement_group_name'] = params['placement_group_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups/{placement_group_name}/sessions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SessionList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_placement_groups_performance(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Get performance metrics of a specific Placement Group  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_groups_performance(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Performance
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_placement_groups_performance_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_placement_groups_performance_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
            return data

    def get_placement_groups_performance_with_http_info(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Get performance metrics of a specific Placement Group  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_groups_performance_with_http_info(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Performance
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tenant_name', 'tenant_space_name', 'placement_group_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_placement_groups_performance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `get_placement_groups_performance`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `get_placement_groups_performance`")  # noqa: E501
        # verify the required parameter 'placement_group_name' is set
        if ('placement_group_name' not in params or
                params['placement_group_name'] is None):
            raise ValueError("Missing the required parameter `placement_group_name` when calling `get_placement_groups_performance`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501
        if 'placement_group_name' in params:
            path_params['placement_group_name'] = params['placement_group_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups/{placement_group_name}/performance', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Performance',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_placement_groups_space(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Get space metrics of a specific Placement Group  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_groups_space(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Space
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_placement_groups_space_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_placement_groups_space_with_http_info(tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
            return data

    def get_placement_groups_space_with_http_info(self, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Get space metrics of a specific Placement Group  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_placement_groups_space_with_http_info(tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Space
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tenant_name', 'tenant_space_name', 'placement_group_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_placement_groups_space" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `get_placement_groups_space`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `get_placement_groups_space`")  # noqa: E501
        # verify the required parameter 'placement_group_name' is set
        if ('placement_group_name' not in params or
                params['placement_group_name'] is None):
            raise ValueError("Missing the required parameter `placement_group_name` when calling `get_placement_groups_space`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501
        if 'placement_group_name' in params:
            path_params['placement_group_name'] = params['placement_group_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups/{placement_group_name}/space', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Space',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_placement_groups(self, tenant_name, tenant_space_name, **kwargs):  # noqa: E501
        """Gets a list of all Placement Groups.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_placement_groups(tenant_name, tenant_space_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroupList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_placement_groups_with_http_info(tenant_name, tenant_space_name, **kwargs)  # noqa: E501
        else:
            (data) = self.list_placement_groups_with_http_info(tenant_name, tenant_space_name, **kwargs)  # noqa: E501
            return data

    def list_placement_groups_with_http_info(self, tenant_name, tenant_space_name, **kwargs):  # noqa: E501
        """Gets a list of all Placement Groups.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_placement_groups_with_http_info(tenant_name, tenant_space_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroupList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tenant_name', 'tenant_space_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_placement_groups" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `list_placement_groups`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `list_placement_groups`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PlacementGroupList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def query_placement_groups(self, region_name, availability_zone_name, array_name, **kwargs):  # noqa: E501
        """Returns a list of Placement Groups from query  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_placement_groups(region_name, availability_zone_name, array_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str region_name: Region that array belongs to. (required)
        :param str availability_zone_name: Availability zone that array belongs to. (required)
        :param str array_name: Return placement-groups across all tenant spaces that are located on the array. (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroupList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.query_placement_groups_with_http_info(region_name, availability_zone_name, array_name, **kwargs)  # noqa: E501
        else:
            (data) = self.query_placement_groups_with_http_info(region_name, availability_zone_name, array_name, **kwargs)  # noqa: E501
            return data

    def query_placement_groups_with_http_info(self, region_name, availability_zone_name, array_name, **kwargs):  # noqa: E501
        """Returns a list of Placement Groups from query  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_placement_groups_with_http_info(region_name, availability_zone_name, array_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str region_name: Region that array belongs to. (required)
        :param str availability_zone_name: Availability zone that array belongs to. (required)
        :param str array_name: Return placement-groups across all tenant spaces that are located on the array. (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: PlacementGroupList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['region_name', 'availability_zone_name', 'array_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method query_placement_groups" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'region_name' is set
        if ('region_name' not in params or
                params['region_name'] is None):
            raise ValueError("Missing the required parameter `region_name` when calling `query_placement_groups`")  # noqa: E501
        # verify the required parameter 'availability_zone_name' is set
        if ('availability_zone_name' not in params or
                params['availability_zone_name'] is None):
            raise ValueError("Missing the required parameter `availability_zone_name` when calling `query_placement_groups`")  # noqa: E501
        # verify the required parameter 'array_name' is set
        if ('array_name' not in params or
                params['array_name'] is None):
            raise ValueError("Missing the required parameter `array_name` when calling `query_placement_groups`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'region_name' in params:
            query_params.append(('region_name', params['region_name']))  # noqa: E501
        if 'availability_zone_name' in params:
            query_params.append(('availability_zone_name', params['availability_zone_name']))  # noqa: E501
        if 'array_name' in params:
            query_params.append(('array_name', params['array_name']))  # noqa: E501

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/resources/placement-groups', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PlacementGroupList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_placement_group(self, body, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Updates a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_placement_group(body, tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PlacementGroupPatch body: (required)
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Operation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_placement_group_with_http_info(body, tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
        else:
            (data) = self.update_placement_group_with_http_info(body, tenant_name, tenant_space_name, placement_group_name, **kwargs)  # noqa: E501
            return data

    def update_placement_group_with_http_info(self, body, tenant_name, tenant_space_name, placement_group_name, **kwargs):  # noqa: E501
        """Updates a specific Placement Group.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_placement_group_with_http_info(body, tenant_name, tenant_space_name, placement_group_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PlacementGroupPatch body: (required)
        :param str tenant_name: The Tenant name (required)
        :param str tenant_space_name: The Tenant Space name (required)
        :param str placement_group_name: The Placement Group name (required)
        :param str x_request_id: The Request ID supplied with the request, used to perform operations idempotently.
        :param str authorization: Access token (in JWT format) required to use any API endpoint.
        :param str x_correlation_id: The Correlation ID provided will be added to log messages and can be used for support. The same Correlation ID may be used for separate requests, to track a higher level workflow.
        :return: Operation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'tenant_name', 'tenant_space_name', 'placement_group_name', 'x_request_id', 'authorization', 'x_correlation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_placement_group" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_placement_group`")  # noqa: E501
        # verify the required parameter 'tenant_name' is set
        if ('tenant_name' not in params or
                params['tenant_name'] is None):
            raise ValueError("Missing the required parameter `tenant_name` when calling `update_placement_group`")  # noqa: E501
        # verify the required parameter 'tenant_space_name' is set
        if ('tenant_space_name' not in params or
                params['tenant_space_name'] is None):
            raise ValueError("Missing the required parameter `tenant_space_name` when calling `update_placement_group`")  # noqa: E501
        # verify the required parameter 'placement_group_name' is set
        if ('placement_group_name' not in params or
                params['placement_group_name'] is None):
            raise ValueError("Missing the required parameter `placement_group_name` when calling `update_placement_group`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'tenant_name' in params:
            path_params['tenant_name'] = params['tenant_name']  # noqa: E501
        if 'tenant_space_name' in params:
            path_params['tenant_space_name'] = params['tenant_space_name']  # noqa: E501
        if 'placement_group_name' in params:
            path_params['placement_group_name'] = params['placement_group_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_request_id' in params:
            header_params['X-Request-ID'] = params['x_request_id']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'x_correlation_id' in params:
            header_params['X-Correlation-ID'] = params['x_correlation_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['accessToken', 'oauth']  # noqa: E501

        return self.api_client.call_api(
            '/tenants/{tenant_name}/tenant-spaces/{tenant_space_name}/placement-groups/{placement_group_name}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Operation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
