# coding: utf-8

"""
    Pure Fusion API

    Pure Fusion is fully API-driven. Most APIs which change the system (POST, PATCH, DELETE) return an Operation in status \"Pending\" or \"Running\". You can poll (GET) the operation to check its status, waiting for it to change to \"Succeeded\" or \"Failed\".   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from fusion.models.resource_post import ResourcePost  # noqa: F401,E501

class HostAccessPoliciesPost(ResourcePost):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'iqn': 'str',
        'personality': 'str'
    }
    if hasattr(ResourcePost, "swagger_types"):
        swagger_types.update(ResourcePost.swagger_types)

    attribute_map = {
        'iqn': 'iqn',
        'personality': 'personality'
    }
    if hasattr(ResourcePost, "attribute_map"):
        attribute_map.update(ResourcePost.attribute_map)

    def __init__(self, iqn=None, personality=None, *args, **kwargs):  # noqa: E501
        """HostAccessPoliciesPost - a model defined in Swagger"""  # noqa: E501
        self._iqn = None
        self._personality = None
        self.discriminator = None
        self.iqn = iqn
        self.personality = personality
        ResourcePost.__init__(self, *args, **kwargs)

    @property
    def iqn(self):
        """Gets the iqn of this HostAccessPoliciesPost.  # noqa: E501

        The iSCSI qualified name (IQN) associated with the host  # noqa: E501

        :return: The iqn of this HostAccessPoliciesPost.  # noqa: E501
        :rtype: str
        """
        return self._iqn

    @iqn.setter
    def iqn(self, iqn):
        """Sets the iqn of this HostAccessPoliciesPost.

        The iSCSI qualified name (IQN) associated with the host  # noqa: E501

        :param iqn: The iqn of this HostAccessPoliciesPost.  # noqa: E501
        :type: str
        """
        if iqn is None:
            raise ValueError("Invalid value for `iqn`, must not be `None`")  # noqa: E501

        self._iqn = iqn

    @property
    def personality(self):
        """Gets the personality of this HostAccessPoliciesPost.  # noqa: E501

        The Personality of the Host machine  # noqa: E501

        :return: The personality of this HostAccessPoliciesPost.  # noqa: E501
        :rtype: str
        """
        return self._personality

    @personality.setter
    def personality(self, personality):
        """Sets the personality of this HostAccessPoliciesPost.

        The Personality of the Host machine  # noqa: E501

        :param personality: The personality of this HostAccessPoliciesPost.  # noqa: E501
        :type: str
        """
        if personality is None:
            raise ValueError("Invalid value for `personality`, must not be `None`")  # noqa: E501
        allowed_values = ["windows", "linux", "aix", "esxi", "hitachi-vsp", "hpux", "oracle-vm-server", "solaris", "vms"]  # noqa: E501
        if personality not in allowed_values:
            raise ValueError(
                "Invalid value for `personality` ({0}), must be one of {1}"  # noqa: E501
                .format(personality, allowed_values)
            )

        self._personality = personality

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HostAccessPoliciesPost, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HostAccessPoliciesPost):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
