# coding: utf-8

"""
    Pure Fusion API

    Pure Fusion is fully API-driven. Most APIs which change the system (POST, PATCH, DELETE) return an Operation in status \"Pending\" or \"Running\". You can poll (GET) the operation to check its status, waiting for it to change to \"Succeeded\" or \"Failed\".   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from fusion.models.resource_post import ResourcePost  # noqa: F401,E501

class NetworkInterfaceGroupPost(ResourcePost):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'group_type': 'str',
        'eth': 'NetworkInterfaceGroupEthPost'
    }
    if hasattr(ResourcePost, "swagger_types"):
        swagger_types.update(ResourcePost.swagger_types)

    attribute_map = {
        'group_type': 'group_type',
        'eth': 'eth'
    }
    if hasattr(ResourcePost, "attribute_map"):
        attribute_map.update(ResourcePost.attribute_map)

    def __init__(self, group_type=None, eth=None, *args, **kwargs):  # noqa: E501
        """NetworkInterfaceGroupPost - a model defined in Swagger"""  # noqa: E501
        self._group_type = None
        self._eth = None
        self.discriminator = None
        self.group_type = group_type
        if eth is not None:
            self.eth = eth
        ResourcePost.__init__(self, *args, **kwargs)

    @property
    def group_type(self):
        """Gets the group_type of this NetworkInterfaceGroupPost.  # noqa: E501

        The type of this Network Interface Group.  # noqa: E501

        :return: The group_type of this NetworkInterfaceGroupPost.  # noqa: E501
        :rtype: str
        """
        return self._group_type

    @group_type.setter
    def group_type(self, group_type):
        """Sets the group_type of this NetworkInterfaceGroupPost.

        The type of this Network Interface Group.  # noqa: E501

        :param group_type: The group_type of this NetworkInterfaceGroupPost.  # noqa: E501
        :type: str
        """
        if group_type is None:
            raise ValueError("Invalid value for `group_type`, must not be `None`")  # noqa: E501
        allowed_values = ["eth"]  # noqa: E501
        if group_type not in allowed_values:
            raise ValueError(
                "Invalid value for `group_type` ({0}), must be one of {1}"  # noqa: E501
                .format(group_type, allowed_values)
            )

        self._group_type = group_type

    @property
    def eth(self):
        """Gets the eth of this NetworkInterfaceGroupPost.  # noqa: E501


        :return: The eth of this NetworkInterfaceGroupPost.  # noqa: E501
        :rtype: NetworkInterfaceGroupEthPost
        """
        return self._eth

    @eth.setter
    def eth(self, eth):
        """Sets the eth of this NetworkInterfaceGroupPost.


        :param eth: The eth of this NetworkInterfaceGroupPost.  # noqa: E501
        :type: NetworkInterfaceGroupEthPost
        """

        self._eth = eth

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NetworkInterfaceGroupPost, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkInterfaceGroupPost):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
