# coding: utf-8

"""
    Pure Fusion API

    Pure Fusion is fully API-driven. Most APIs which change the system (POST, PATCH, DELETE) return an Operation in status \"Pending\" or \"Running\". You can poll (GET) the operation to check its status, waiting for it to change to \"Succeeded\" or \"Failed\".   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from fusion.models.resource_post import ResourcePost  # noqa: F401,E501

class SnapshotPost(ResourcePost):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'volumes': 'list[str]',
        'placement_group': 'str'
    }
    if hasattr(ResourcePost, "swagger_types"):
        swagger_types.update(ResourcePost.swagger_types)

    attribute_map = {
        'volumes': 'volumes',
        'placement_group': 'placement_group'
    }
    if hasattr(ResourcePost, "attribute_map"):
        attribute_map.update(ResourcePost.attribute_map)

    def __init__(self, volumes=None, placement_group=None, *args, **kwargs):  # noqa: E501
        """SnapshotPost - a model defined in Swagger"""  # noqa: E501
        self._volumes = None
        self._placement_group = None
        self.discriminator = None
        if volumes is not None:
            self.volumes = volumes
        if placement_group is not None:
            self.placement_group = placement_group
        ResourcePost.__init__(self, *args, **kwargs)

    @property
    def volumes(self):
        """Gets the volumes of this SnapshotPost.  # noqa: E501

        List of volume names to have snapshots taken of.  # noqa: E501

        :return: The volumes of this SnapshotPost.  # noqa: E501
        :rtype: list[str]
        """
        return self._volumes

    @volumes.setter
    def volumes(self, volumes):
        """Sets the volumes of this SnapshotPost.

        List of volume names to have snapshots taken of.  # noqa: E501

        :param volumes: The volumes of this SnapshotPost.  # noqa: E501
        :type: list[str]
        """

        self._volumes = volumes

    @property
    def placement_group(self):
        """Gets the placement_group of this SnapshotPost.  # noqa: E501

        Placement Group to take snapshot of.  # noqa: E501

        :return: The placement_group of this SnapshotPost.  # noqa: E501
        :rtype: str
        """
        return self._placement_group

    @placement_group.setter
    def placement_group(self, placement_group):
        """Sets the placement_group of this SnapshotPost.

        Placement Group to take snapshot of.  # noqa: E501

        :param placement_group: The placement_group of this SnapshotPost.  # noqa: E501
        :type: str
        """

        self._placement_group = placement_group

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SnapshotPost, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SnapshotPost):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
