# coding: utf-8

"""
    Pure Fusion API

    Pure Fusion is fully API-driven. Most APIs which change the system (POST, PATCH, DELETE) return an Operation in status \"Pending\" or \"Running\". You can poll (GET) the operation to check its status, waiting for it to change to \"Succeeded\" or \"Failed\".   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Space(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource': 'ResourceReference',
        'total_physical_space': 'int'
    }

    attribute_map = {
        'resource': 'resource',
        'total_physical_space': 'total_physical_space'
    }

    def __init__(self, resource=None, total_physical_space=None):  # noqa: E501
        """Space - a model defined in Swagger"""  # noqa: E501
        self._resource = None
        self._total_physical_space = None
        self.discriminator = None
        if resource is not None:
            self.resource = resource
        if total_physical_space is not None:
            self.total_physical_space = total_physical_space

    @property
    def resource(self):
        """Gets the resource of this Space.  # noqa: E501


        :return: The resource of this Space.  # noqa: E501
        :rtype: ResourceReference
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Space.


        :param resource: The resource of this Space.  # noqa: E501
        :type: ResourceReference
        """

        self._resource = resource

    @property
    def total_physical_space(self):
        """Gets the total_physical_space of this Space.  # noqa: E501

        Total physical space  # noqa: E501

        :return: The total_physical_space of this Space.  # noqa: E501
        :rtype: int
        """
        return self._total_physical_space

    @total_physical_space.setter
    def total_physical_space(self, total_physical_space):
        """Sets the total_physical_space of this Space.

        Total physical space  # noqa: E501

        :param total_physical_space: The total_physical_space of this Space.  # noqa: E501
        :type: int
        """

        self._total_physical_space = total_physical_space

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Space, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Space):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
